/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :      
Version : v1.0 Beta
Date    : 25.10.2014
Author  : camokat-betepaha
Company : http://www.drive2.ru/
Comments: 


Chip type               : ATtiny13A
AVR Core Clock frequency: 1,200000 MHz
Memory model            : Tiny
External RAM size       : 0
Data Stack size         : 16
*****************************************************/
typedef unsigned char byte;

#include <tiny13a.h>
#include <delay.h>

#define KEY  PINB.0   

#define OUT1  PORTB.1  
#define OUT2  PORTB.2  
#define SPK1  PORTB.3
#define SPK2  PORTB.4

#define LONGKEY 20 //    ""   2   2 
#define SETUP 100 //                 10 

void BEEP(byte tone, byte length) 
 {
  byte i,r;
  for(i=0;i<length;i++)
    {
     if (SPK1)
     {
      SPK1=0;
      SPK2=1;
     }
     else 
     {
      SPK1=1;
      SPK2=0;
     }   
     for(r=0;r<tone;r++)delay_us(15); 
    }
    SPK1=0;
    SPK2=0;
  }
void BEEP_UP (void)
 {  
  BEEP(25,150);
  BEEP(15,250);
 }  
void BEEP_DOWN (void)
 {
  BEEP(15,250); 
  BEEP(25,150);
 }

void BEEP_OK (void)
 {  
  BEEP(15,255);
 } 
 
 byte counter,setcount,timer,time1,time2;
 eeprom byte eetime1,eetime2;
 unsigned int timeroff1,timeroff2;

void main(void)
{
DDRB= (0<<DDB5)   | (1<<DDB4)   | (1<<DDB3)   | (1<<DDB2)   | (1<<DDB1)   | (0<<DDB0);
PORTB=(0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (1<<PORTB0);

TCCR0A=(0<<COM0A1) | (0<<COM0A0) | (0<<COM0B1) | (0<<COM0B0) | (0<<WGM01) | (0<<WGM00);
TCCR0B=(0<<WGM02)  | (1<<CS02)   | (0<<CS01)   | (1<<CS00);
TCNT0=0x8B;
TIMSK0=(0<<OCIE0B) | (0<<OCIE0A) | (1<<TOIE0);
ACSR=     (1<<ACD) | (0<<ACBG)   | (0<<ACO)    | (0<<ACI)    | (0<<ACIE)  | (0<<ACIS1)  | (0<<ACIS0);

time1=eetime1;
time2=eetime2;
#asm("sei")
}
interrupt [TIM0_OVF] void timer0_ovf_isr(void)  // 10   
 {
  TCNT0=0x8B;
   if(KEY==0)                      //   
     { 
      if(counter!=255)counter++;
      if(counter==LONGKEY)
       {
        if(OUT1)
         {
          OUT1=0;
          BEEP_DOWN();
         }
        else 
         {
          OUT1=1;
          BEEP_UP();
         } 
       }
       if(counter>SETUP)
       {
        
        setcount++;
        if(setcount>10)
        { 
         
         if(timer<100)timer++;    
         BEEP_OK();
         setcount=0;
        }
       }
      }
   else                              //   
   {
    if(counter>1)
     {  
      if(counter<LONGKEY&&counter<=SETUP)
       {
       if(OUT2)
         {
          OUT2=0;
          BEEP_DOWN();
         }
        else 
         {
          OUT2=1;
          BEEP_UP();
         }
       }
      if(counter>SETUP)
       {
        if(OUT1)eetime1=time1=timer;
        if(OUT2)eetime2=time2=timer;
        timer=0;
        BEEP_UP();
        BEEP_UP();
        BEEP_UP();
       }
     }
    counter=0;
    if(timer==0)timer=1;
    
    if(OUT1&&time1!=0)
     {
      if(timeroff1<0xFFFF)timeroff1++;
     }
    else timeroff1=0; 
     if(OUT2&&time2!=0)
     {
      if(timeroff2<0xFFFF)timeroff2++;
     }
    else timeroff2=0;
    
    if (timeroff1>(time1)*600)
     { 
      OUT1=0;
      BEEP_DOWN();
     }
    if (timeroff2>(time2)*600)
     { 
      OUT2=0;
      BEEP_DOWN();
     }
   }
   
 }


